defmodule EctoMySQLExtras.AllLocks do
  @behaviour EctoMySQLExtras

  def info do
    %{
      title: "Queries with active locks"
    }
  end

  def query(_args \\ []) do
    """
    /* ECTO_MYSQL_EXTRAS: #{info().title} */

    SELECT
      TABLE_SCHEMA AS `schema`,
      TABLE_NAME AS `name`,
      ENGINE AS `engine`,
      DATA_LENGTH AS `size`
    FROM information_schema.tables
    WHERE TABLE_SCHEMA = DATABASE()
    AND TABLE_TYPE <> 'VIEW'
    ORDER BY `size` DESC;
    """
  end
end
